unit sDisks;

interface
uses charfile,hex;

const
MaxPart=60;
BT2SC=512;

type
tRngPart=1..MaxPart;
tDscPart=record
    Name:String[15];
    Mode:Word;
   Start:Longint;
     Fin:Longint;
	 end;
tArrDesc=array[tRngPart] of tDscPart;

var
{ ࢠ ⠡ ᯮ  ⥭ ⠡ 権,
    ⥭ ᢮ 䨣 }
PartDesc,LibrDesc:tArrDesc;

{ 0 -  १ BIOS, 1 - אַ 16-  }
sdAccess:byte;

{ Init    init }
procedure Init;

{ Append PartDesc  fo }
procedure AppendDesc;

{ 頥 Desc }
procedure ClearDesc(var Desc:tArrDesc);

{ ⠥  fi  LibrDesc }
procedure LoadDesc;

{  ठ  EDD BIOS }
procedure SizeFromBIOS(const Drive:byte);

{  ठ  IdentLBA }
procedure SizeFromHard(const Drive:byte);

{  ठ  ᨬ᪮ ਡ }
procedure SizeAssympt(const Drive:byte);

{ ஢ boot record  । ४⭮  頥  ᫥ ᥪ ࠧ }
 function TestPart(const Sector:LongInt; const Drive:byte; var Finish:Longint):Boolean;

{ ⠥ ⠡ ࠧ  PartDesc }
procedure ListPart(const Drive:byte);

{ 뢮  ࠭ ᫮ 䫠 }
procedure ViewFlags(const Flag:word);

{  Flags  ᮮ⢥⢨  ப }
 function Str2Flags(Flags:word; const s:string):word;

{ 뢮 ⠡  ।    . 頥  }
procedure DescSelect(const Dsc:tArrDesc; var St,Fn:LongInt);

implementation
const
BaseName='Sevilija.cfg';

type
twBuf=array[0..255] of Word;
tlBuf=array[0..127] of LongInt;
tbBuf=array[0..511] of Byte;
tPtLine=record
	  Boot:byte;
	 Head1:byte;
	 TrSc1:word;
	   Sys:byte;
	 Head2:byte;
	 TrSc2:word;
	  Offs:Longint;
	 Count:Longint;
	end;
tPtTable=record
	   Res0:array[$0..$1bd] of Byte;
	   Line:array[1..4] of tPtLine;
	   Sign:word;
	 end;
var
fo:text; fi:tf;
n:tRngPart;
ReadSectTime:boolean;
ReadSectCode,dr:byte;
p1,p2:word;

procedure ViewFlags;
begin
if Flag and 1 = 0 then write('-') else write('C');
if Flag and 2 = 0 then write('-') else write('R');
if Flag and 4 = 0 then write('-') else write('W');
if Flag and 8 = 0 then write('-') else write('N');
end;

function Str2Flags;
var n:byte;
begin
for n:=1 to length(s) do
  case s[n] of
  'N': Flags:=Flags or 8;
  'n': Flags:=Flags and ($ffff xor 8);
  'W': Flags:=Flags or 4;
  'w': Flags:=Flags and ($ffff xor 4);
  'R': Flags:=Flags or 2;
  'r': Flags:=Flags and ($ffff xor 2);
  end;
Str2Flags:=Flags;
end;

function GetOfsP(const Drive:byte):boolean;
const
  ofsp:array[0..3] of record p1,p2:word end=(
    (p1:$1f0;p2:$3f6),(p1:$170;p2:$376),(p1:$1e8;p2:$3ee),(p1:$168;p2:$36e)
  );
begin
  if Drive in [128..135] then begin
    dr:=(Drive and 7) div 2;
    p1:=ofsp[dr].p1; p2:=ofsp[dr].p2;
    dr:=((Drive and 1) shl 4) or $e0;
    GetOfsP:=False;
  end else begin
    GetOfsP:=True;
  end;
end;

procedure ErrorsDecode(const pr:string; const sc:longint);
begin
  if sdAccess=0 then begin
    if ReadSectCode<>0 then begin
      Writeln(pr,': Sector # ',sc,', BIOS error # ',ReadSectCode,'.');
      halt(1);
    end;
  end else begin
    if ReadSectTime then
      begin Writeln(pr,': Sector # ',sc,', time out.'); halt(8) end
     else
      if ReadSectCode<>0 then begin
	Write(pr,': Sector # ',sc,', HARD error code $'); hexout(ReadSectCode); writeln('.');
	halt(9);
      end;
  end;
end;

procedure GetStatus(const mask:byte);
var
  Timer:LongInt absolute $0040:$006C;
  Time:LongInt;
begin
  Time:=Timer+18;
  while (port[p1+7] and $80<>0) and (Timer<Time) do ;
  while (port[p1+7] and mask=0) and (Timer<Time) do ;
  ReadSectTime:=Timer>=Time;
  if (port[p1+7] and 1 <> 0) and (mask=$08) then
    ReadSectCode:=port[p1+1] else ReadSectCode:=0;
end;

procedure LBAConvert(const as:longint; const cmd:byte);
begin
  Port[p2+0]:=2; {  뢠,   믮 }
  Port[p1+2]:=1;
  Port[p1+3]:=  as         and $ff;
  Port[p1+4]:= (as shr  8) and $ff;
  Port[p1+5]:= (as shr 16) and $ff;
  Port[p1+6]:=((as shr 24) and $0f)+dr;
  Port[p1+7]:=cmd;
end;

procedure ReadSect(const Sector:LongInt; const Drive:Byte; var Buf:tbBuf);
type
tDAP=record
    len:byte; { 16 }
    rs0:byte; { 0 }
  count:byte; { 1..127 }
    rs1:byte; { 0 }
 buffer:pointer;
 startL:longint;
 startH:longint;
     end;

var DAP:tDAP; pDAP:^tDAP;

begin
  if sdAccess=0 then begin
    with DAP do
      begin
	len:=16; rs0:=0;
	count:=1; rs1:=0;
	buffer:=@Buf;
	startL:=Sector; startH:=0;
      end;

    pDAP:=@DAP;

    asm
      mov dl,Drive
      mov ah,$42
      push ds
      lds si,pDAP

      int $13
      pop ds
      jc @1
      xor ah,ah
    @1:
      mov ReadSectCode,ah
    end;
  end else begin
    if GetOfsP(Drive) then begin
      ReadSectTime:=True;
    end else begin
      GetStatus($40);
      if ReadSectTime or (ReadSectCode<>0) then exit;
      LBAConvert(Sector,$20); GetStatus($08);
      asm
	mov dx,p1
	mov cx,256
	les di,Buf
	rep insw
      end;
      Port[p2+0]:=0;
    end;
  end;
end;

procedure SizeFromBIOS;
label HDD_NoExt,HDD_NoFD,HDD_GDPErr,HDD_IsLarge,HDD_B2SErr;
type
  ttbl_Prm=record
    Len	:word;
    Fl	:word;
    Tr	:longint;
    Hd	:longint;
    Sc	:longint;
    AScL:longint;
    AScH:longint;
    B2S	:word;
  end;

var
  version:byte;
  tbl_Prm:ttbl_Prm;
  ptbl_Prm:^ttbl_Prm;

begin
  ptbl_Prm:=@tbl_Prm;
  Writeln(' ࠧ   EDD BIOS...');
  tbl_Prm.Len:=26;
  asm
    mov	ah,$41
    mov	bx,$55aa
    mov	dl,Drive
    int	$13
    jc	HDD_NoExt
    cmp	bx,$0aa55
    jne	HDD_NoExt
    mov version,ah
    and	cx,1
    jz	HDD_NoFD

    mov	ah,$48
    mov	dl,Drive
    push ds
      lds si,ptbl_Prm
      nop
      int $13
    pop ds
    jc	HDD_GDPErr
    cmp	tbl_Prm.B2S,BT2SC
    jne	HDD_B2SErr
    db $66 ; cmp word ptr tbl_Prm.AScH,0
    jne	HDD_IsLarge
   end;
   write('   EDD: ');
   case version of
     $01: Writeln('1.x');
     $20: Writeln('2.0 / EDD-1.0');
     $21: Writeln('2.1 / EDD-1.1');
     $30: Writeln('EDD-3.0');
    else
     hexout(version); writeln('h');
   end;
   writeln('  ⮣ ',tbl_Prm.AScL,' ᥪ஢  ',tbl_Prm.AScL div 2048,' M.');
   Writeln; exit;
   HDD_NoFD:   writeln('    fixed disk  ন 騬 EDD.'); exit;
   HDD_NoExt:  writeln('  BIOS Enhanced Disk Drive Services (EDD) .'); exit;
   HDD_GDPErr: writeln('  訡  ⢥   Get Device Parameters.'); exit;
   HDD_B2SErr: writeln('   ᥪ <> ',BT2SC,' .'); exit;
   HDD_IsLarge:writeln('   ᪠ > $ffff ffff ᥪ஢.'); exit;
end;

procedure SizeFromHard;
var Size:Longint;

function intErrors(const pr:string):boolean;
begin
  intErrors:=True;
  if ReadSectTime then begin
    writeln('   ⮢  ',pr,': ६  ⥪.');
    intErrors:=False;
  end else if ReadSectCode<>0 then begin
    writeln('   ⮢  ',pr,': 訡. 祭  訡: ',ReadSectCode,'.');
    intErrors:=False;
  end;
end;

begin
  Writeln(' ࠧ  筮 (Identify Device, Offset 60, Access 16 bit)...');

  if GetOfsP(Drive) then begin
    Writeln('  אַ   ⮫쪮  ன 128..135.'#13#10);
    exit;
  end;
  GetStatus($40);
  if intErrors('') then begin
    LBAConvert(0,$EC); GetStatus($08);
    if intErrors('। ') then begin
      asm { 㦭  ᫮  ᬥ饭 60 }
	mov dx,p1
	mov cx,61
      @1:
	in ax,dx
	loop @1
	mov word ptr Size+0,ax
	in ax,dx
	mov word ptr Size+2,ax
	mov cx,194
      @2:
	in ax,dx
	loop @2
      end;
      if Size=0 then
	Writeln('   㫥 ࠧ. ⭮, LBA   ন.'#13#10+
		'   ᫥⥫쭮 ਡ  אַ 㯥   .')
      else
	Writeln('  ⮣ ',Size,' ᥪ஢  ',Size div 2048,' .');
    end;
  end;
  Writeln;
  Port[p2+0]:=0;
end;

procedure SizeAssympt;
var Min,Max,ASec:Longint; b:tbBuf; n:byte;

begin
Min:=0; Max:=$fffffff;

Writeln('業 ࠧ  ᫥⥫ ਡ...'); n:=0;
Write('    : '); if sdAccess=0 then writeln('१ EDD BIOS.') else writeln('אַ, 16-, LBA.');

repeat
  ASec:=Min+((Max-Min) div 2); Write(ASec:12,':');
  ReadSect(ASec,Drive,b);
  if ((sdAccess=0) or not ReadSectTime) and (ReadSectCode=0) then
    begin write('Ok '); Min:=ASec end
  else
    begin write('Err'); Max:=ASec end;
  if n<3 then inc(n) else begin n:=0; writeln end;
until (Min=Max) or (Min+1=Max);

if (Min+1=Max) and (ReadSectCode<>0) then ASec:=Max;

Writeln(#13#10'  ⮣ ',ASec,' ᥪ஢  ',ASec div 2048,' .');
Writeln;
end;

function TestPart;
var wBuf:twBuf; lBuf:tlBuf absolute wBuf; bBuf:tbBuf absolute wBuf;
begin
TestPart:=False;
ReadSect(Sector,Drive,bBuf); ErrorsDecode('TestPart',Sector);
if wBuf[255]=$AA55 then
  begin
    TestPart:=True;
    Finish:=bBuf[$14]*256+bBuf[$13];
    if Finish=0 then Finish:=lBuf[$8]; { bBuf[$20] }
    Finish:=Finish+Sector;
  end
end;

procedure ClearDesc;
begin for n:=Low(tRngPart) to High(tRngPart) do Desc[n].name:='' end;

procedure ListPart;
var DriveLetter:char; From:tRngPart;

procedure LP_1(ExtOffs,CurrOffs:LongInt);
var BFin:LongInt; n:byte;
wBuf:twBuf; lBuf:tlBuf absolute wBuf; bBuf:tbBuf absolute wBuf; PtTable:tPtTable absolute wBuf;
begin
ReadSect(CurrOffs,Drive,bBuf); ErrorsDecode('ListPart',CurrOffs);

for n:=1 to 4 do
  with PtTable.Line[n] do
    case Sys of
      1,4,6,$b,$c,$e:
      with PartDesc[From] do
	begin
	  Name:=DriveLetter+':'; inc(DriveLetter);
	  Start:=Offs+CurrOffs; Fin:=Offs+Count+CurrOffs;
	  Write(Name,' ',Start:9,'..',Fin,#9'(',Count div 2048:5,' Mb)');
	  if not TestPart(Start,Drive,BFin) then Write(' ! Boot Record incorrect !');
	  if Fin<>BFin then Write(' ! Boot Record info: Fin = ',BFin);
	  inc(From); WriteLn;
	end;
      5,$f:
      begin
	if ExtOffs=0 then ExtOffs:=CurrOffs;
	writeln('Ex ',Offs+CurrOffs:9,'..',Offs+Count+CurrOffs,#9'(',Count div 2048:5,' Mb)');
	LP_1(ExtOffs,Offs+ExtOffs);
      end;
    end;
end;

begin
ClearDesc(PartDesc);
WriteLn('--  ⠡ ࠧ --'); From:=Low(tRngPart);
DriveLetter:='C'; LP_1(0,0);
WriteLn;
end;

procedure AppendDesc;
begin
append(fo);
for n:=Low(tRngPart) to High(tRngPart) do
  with PartDesc[n] do
    if name<>'' then writeln(fo,name,#9,'R',#9,Start,#9,Fin);
close(fo);
end;

procedure DescSelect;
begin
WriteLn;
for n:=Low(tRngPart) to High(tRngPart) do
  with Dsc[n] do
    if name<>'' then writeln(n:2,'.',name:16,Start:10,Fin:10,(Fin-Start) div 2048:6,' Mb');
Write('Enter number : '); ReadLn(n);
St:=Dsc[n].Start; Fn:=Dsc[n].Fin;
end;

procedure LoadDesc;
begin
{$I-}
reset(fi);
if IOResult<>0 then
  begin
    Writeln('   䠩 䨣樨 "',BaseName,'".');
    halt(3);
  end;
{$I+}
ClearDesc(LibrDesc);
n:=Low(tRngPart);
while not eof(fi) do
  with LibrDesc[n] do
    begin
      name:=readS(fi);
      if length(name)>0 then
	if name[1]<>'#' then
	  begin
	    mode:=1;
	    mode:=Str2Flags(mode,readS(fi));
	    Start:=readL(fi);
	    Fin:=readL(fi);
	    inc(n);
	  end;
      readC(fi);
    end;
close(fi);
end;

procedure Init;
var s:string; n:byte;
begin
s:=ParamStr(0); n:=Length(s);
while (n>0) and (s[n]<>'\') do dec(n); s[0]:=chr(n);
Assign(fi,s+BaseName);
Assign(fo,s+BaseName);
end;

end.