uses crt,slink;

{ ⥫ : "ଠ  室  ॡ㥬  饣 ꥬ" }

type
  tFS		= (fsFAT12,fsFAT16);

const
  {  ࠭ ப  ࠧ ᮮ饭 }
  slErrors	= 18;

  bt2sc		= 512;
  ioRead	= 0;
  ioWrite	= 1;
  LDrive		: Byte=0;

  FSParams	: array[tFS] of record
    NumClast	: Word;
    AttClast	: Word;
    FillFAT	: Longint;
    cl2sfat	: Word;
  end=(
    (NumClast	: $FF5-2+1;  AttClast:$FEF-2+1;  FillFAT:$00FFFFF8; cl2sfat:341),
    (NumClast	: $FFF5-2+1; AttClast:$FFEF-2+1; FillFAT:$FFFFFFF8; cl2sfat:256)
  );


type
  tUndefStr	= array[0..10] of Char;
  tParams	= (Pv_name,Pbt2sc,Psc2cl,Pres_sec,Pfat_num,Proot_ent,
		   Psec_num_o,Pmedia,Psc2fat,Psc2tr,Pheads,Poffset,
		   Psec_num_n,Phdd_num,Psign,Pserial_num,Pd_name,Pfs_name,
		   Pall_size,Pdata_size,Proot_size,Pfats_size,Pclast_num,
		   PFS_type,PLDrive);

  tBootRec	= record
    jmp		: array[0..2] of Byte;
    v_name	: array[0..7] of Char; { $03, $0B, $0D, $0E, $10, $11, $13 }
    bt2sc	: Word;
    sc2cl	: Byte;
    res_sec	: Word;
    fat_num	: Byte;
    root_ent	: Word;
    sec_num_o	: Word;
    media	: Byte; { $15, $16, $18, $1A, $1c, $20, $24 }
    sc2fat	: Word;
    sc2tr	: Word;
    heads	: Word;
    offset	: Longint;
    sec_num_n	: Longint;
    hdd_num	: Byte;
    reserved	: Byte;
    sign	: Byte; { $26, $27, $2b, $36 }
    serial_num	: Longint;
    d_name	: array[0..10] of Char;
    fs_name	: array[0..7] of Char;
  end;

  tDAP		= record
    Start	: Longint;
    Count	: Word;
    Buffer	: Pointer;
  end;

  tSector	= array[0..bt2sc-1] of Byte;

  tActions	= (acByteEdit,acWordEdit,acLongEdit,acStrEdit,
		   acLongView,acFSEdit,acDrvEdit);

var
  BootSec	: tSector;
  BootRec	: tBootRec absolute BootSec;
  FS		: tFS;
  Key		: Char;

  {  室  boot record,   ࠢ 㦭 }
  all_size	: Longint;
  data_size	: Longint;
  root_size	: Longint;
  fats_size	: Longint;
  clast_num	: Longint;
  sec_num	: Longint;

  desc:array[0..31] of record
    st,fn	: longint;
    ln		: longint;
    dr		: byte;
    Flag	: word;
  end;


procedure SearchLDrive;
var n:byte;
begin
  for LDrive:=0 to 31 do desc[LDrive].ln:=0;
  for Drive:=0 to 255 do
    if TestDriver then with pDriveData^ do
      for n:=1 to NumberDev do begin
	LDrive:=n+StartDev-1;
	desc[LDrive].st:=paDskHd^[n].sDskSt;
	desc[LDrive].fn:=paDskHd^[n].sDskFn;
	desc[LDrive].Flag:=paDskHd^[n].sDskFlag;
	desc[LDrive].ln:=desc[LDrive].fn-desc[LDrive].st;
	desc[LDrive].dr:=Drive;
      end;
end;

procedure subCalc1;
var FFS:tFS;
begin
  with BootRec do begin
    if clast_num + 1 > $ff5 then FFS:=fsFAT16 else FFS:=fsFAT12;
    if FFS <> FS then begin
      write('⠭  FS  ࠢ 㤥 ந஢ DOS.'#13#10+
	' 㤥 業    FAT1');
      case FFS of
	fsFAT12: writeln('2.');
	fsFAT16: writeln('6.');
      end;
    end;
  end;
end;

procedure subCalc0;
begin
  with BootRec do begin
    clast_num:=(sec_num-res_sec-fats_size-root_size) div sc2cl; subCalc1;
    data_size:=clast_num*sc2cl;
    if clast_num>FSParams[FS].NumClast then writeln('砥 ᫨誮 讥 ᫮ ஢.') else
      if clast_num>FSParams[FS].AttClast then writeln('᫮ ஢ 室  ⨬ ,   맢'+
	#13#10'䫨  묨 ணࠬ (ndd, diskedit, scandisk).');
    sc2fat:=(clast_num+FSParams[FS].cl2sfat-1) div FSParams[FS].cl2sfat;
    fats_size:=sc2fat*fat_num;
    all_size:=res_sec+fats_size+root_size+data_size;
  end;
end;

{ ========  楤 bl*  㬠   (᫨  
  㦭), २⢥ - 㬠  ======== }

procedure blSorry(const Param:tParams); far;
begin
  writeln('  㤥 ண  ࠬ...');
  case Param of
    Pbt2sc: BootRec.bt2sc:=bt2sc;
    Psign : BootRec.sign:=41;
  end;
end;

procedure blSc2Cl(const Param:tParams); far;
begin
  with BootRec do begin
    if sc2cl=0 then begin
      writeln(' .     ࠢ 0,   訡   0.');
      sc2cl:=1;
    end;
    if sc2cl>=128 then writeln('ᯮ ᭮ 祭: ᥪ஢     ࠢ 128.'#13#10+
      '⠭ ଠ  ন  祭, ,  砩...');
    if not (sc2cl in [1,2,4,8,16,32,64,128]) then
      writeln('⢮ ᥪ஢     ⥯ '#13#10+
      '(1,2,4,8,16,32,64,128),   直,  ⮬ ᫥  ''.');
    subCalc0;
  end;
end;

procedure blRes_sec(const Param:tParams); far;
begin
  with BootRec do begin
    if res_sec>1 then writeln('筮  祭  ࠢ 1...');
    if res_sec<1 then writeln(' ⮬ 砥   Boot Record !!!');
    all_size:=res_sec+fats_size+root_size+data_size;
  end;
end;

procedure blFat_num(const Param:tParams); far;
begin
  with BootRec do begin
    if fat_num<1 then begin
      writeln('   FAT -    筮.');
      fat_num:=1;
    end;
    if fat_num>2 then writeln(' ணࠬ      FAT, ਬ DiskEdit.');
    fats_size:=sc2fat*fat_num;
    all_size:=res_sec+fats_size+root_size+data_size;
  end;
end;

procedure blRoot_ent(const Param:tParams); far;
begin
  with BootRec do begin
    if root_ent<1 then begin
      writeln(' ୥ ⠫  㦥   .');
      root_ent:=1;
    end;
    if root_ent mod 16 <> 0 then writeln('⥫쭮, ⮡  祭 뫮 ⭮ 16.');
    root_size:=(root_ent+15) div 16;
    if (root_ent<>512) and (root_ent<>224) then
      writeln(' ணࠬ, த scandisk  ndd,   祭 ⮣ ᫠'#13#10+
      '<> 512  ஢ ( ࠩ , ᫨ ᫮  FAT>1)  224 '#13#10+
      '᪥.');
    all_size:=res_sec+fats_size+root_size+data_size;
  end;
end;

procedure blRoot_size(const Param:tParams); far;
begin
  with BootRec do begin
    root_ent:=root_size*16;
    if (root_size<>14) and (root_size<>32) then
      writeln(' ணࠬ, த scandisk  ndd,   祭 ⮣ ᫠'#13#10+
      '<> 32  ஢ ( ࠩ , ᫨ ᫮  FAT>1)  14 '#13#10+
      '᪥.');
    all_size:=res_sec+fats_size+root_size+data_size;
  end;
end;

procedure blSect_num_o(const Param:tParams); far;
begin
  with BootRec do begin
    sec_num_n:=0; sec_num:=sec_num_o;
    subCalc0;
  end;
end;

procedure blSec2fat(const Param:tParams); far;
begin
  with BootRec do begin
    if sc2fat<(clast_num+FSParams[FS].cl2sfat-1) div FSParams[FS].cl2sfat then
      writeln(' ᭮,  ⠪ ࠧ FAT 㤥 筮.');
  end;
end;

procedure blSect_num_n(const Param:tParams); far;
begin
  with BootRec do begin
    sec_num_o:=0; sec_num:=sec_num_n;
    subCalc0;
  end;
end;

procedure blFS(const Param:tParams); far;
begin
  case FS of
    fsFAT12: BootRec.fs_name:='FAT12   ';
    fsFAT16: BootRec.fs_name:='FAT16   ';
  end;
  subCalc0;
end;

procedure blMedia(const Param:tParams); far;
begin
  if BootRec.media<>248 then writeln('⥫쭮, ⮡  ࠬ  ࠢ 248  ஢  240  ᪥.');
end;

const
  Params	: array[tParams] of record
    Name	: String[32];
    Action	: tActions;
    Rout	: Procedure(const Param:tParams);
    StrLen	: Byte;
    case Byte of
      1: (bVal	: ^Byte);
      2: (wVal	: ^Word);
      3: (lVal	: ^Longint);
      4: (sVal	: ^tUndefStr);
  end=(
    (Name:'䨪 ந⥫';	Action:acStrEdit;  Rout:Nil; StrLen:7),
    (Name:'  ᥪ';			Action:acWordEdit; Rout:blSorry),
    (Name:'஢  ';		Action:acByteEdit; Rout:blSc2Cl),
    (Name:'饭 砫 FAT';		Action:acWordEdit; Rout:blRes_sec),
    (Name:'᫮  FAT';			Action:acByteEdit; Rout:blFat_num),
    (Name:'ᥩ  ୥ ⠫';	Action:acWordEdit; Rout:blRoot_ent),
    (Name:'ᥣ ᥪ஢ (ॢ襥)';	Action:acWordEdit; Rout:blSect_num_o),
    (Name:' ਯ';			Action:acByteEdit; Rout:blMedia),
    (Name:'஢  FAT';			Action:acWordEdit; Rout:blSec2fat),
    (Name:'஢  ४';			Action:acWordEdit; Rout:Nil),
    (Name:'';				Action:acWordEdit; Rout:Nil),
    (Name:'饭 ࠧ  砫 ᪠';	Action:acLongEdit; Rout:Nil),
    (Name:'ᥣ ᥪ஢ (७)';	Action:acLongEdit; Rout:blSect_num_n),
    (Name:'᪨  ன⢠';	Action:acByteEdit; Rout:Nil),
    (Name:'७ ᨣ';		Action:acByteEdit; Rout:blSorry),
    (Name:'਩ ';			Action:acLongEdit; Rout:Nil),
    (Name:'⪠ ⮬';				Action:acStrEdit;  Rout:Nil; StrLen:10),
    (Name:' 䠩 ⥬';		Action:acStrEdit;  Rout:Nil; StrLen:7),
    (Name:'ᥣ ᥪ஢ (ᯮ㥬)';	Action:acLongView; Rout:Nil),
    (Name:'஢ 짮⥫᪨ ';	Action:acLongView; Rout:Nil),
    (Name:' ୥ ⠫';		Action:acLongEdit; Rout:blRoot_size),
    (Name:'஢    FAT';		Action:acLongView; Rout:Nil),
    (Name:'஢';				Action:acLongView; Rout:Nil),
    (Name:' 䠩 ⥬';		Action:acFSEdit;   Rout:blFS),
    (Name:'ன⢮';				Action:acDrvEdit;  Rout:Nil)
  );


procedure Linking;
begin
  Params[Pv_name]	.sVal:=@BootRec.v_name;
  Params[Pbt2sc]	.wVal:=@BootRec.bt2sc;
  Params[Psc2cl]	.bVal:=@BootRec.sc2cl;
  Params[Pres_sec]	.wVal:=@BootRec.res_sec;
  Params[Pfat_num]	.bVal:=@BootRec.fat_num;
  Params[Proot_ent]	.wVal:=@BootRec.root_ent;
  Params[Psec_num_o]	.wVal:=@BootRec.sec_num_o;
  Params[Pmedia]	.bVal:=@BootRec.media;
  Params[Psc2fat]	.wVal:=@BootRec.sc2fat;
  Params[Psc2tr]	.wVal:=@BootRec.sc2tr;
  Params[Pheads]	.wVal:=@BootRec.heads;
  Params[Poffset]	.lVal:=@BootRec.offset;
  Params[Psec_num_n]	.lVal:=@BootRec.sec_num_n;
  Params[Phdd_num]	.bVal:=@BootRec.hdd_num;
  Params[Psign]		.bVal:=@BootRec.sign;
  Params[Pserial_num]	.lVal:=@BootRec.serial_num;
  Params[Pd_name]	.sVal:=@BootRec.d_name;
  Params[Pfs_name]	.sVal:=@BootRec.fs_name;

  Params[Pall_size]	.lVal:=@all_size;
  Params[Pdata_size]	.lVal:=@data_size;
  Params[Proot_size]	.lVal:=@root_size;
  Params[Pfats_size]	.lVal:=@fats_size;
  Params[Pclast_num]	.lVal:=@clast_num;

  Params[PLDrive]	.bVal:=@LDrive;
end;

var
  { RWTS }
  DAP		: tDAP;
  ExitCodeRWLS	: Word;
  ioMode	: Byte;

procedure RWTS(const Buf:tSector; const Num:Longint);
begin
  with DAP do begin
    Start:=Num;
    Count:=1;
    Buffer:=@Buf;
  end;
  asm
    mov ah,ioMode
    push bp
    push ds
    mov al,LDrive
    mov cx,$ffff
    mov bx,Seg DAP
    mov ds,bx
    mov bx,Offset DAP
    cmp ioMode,ioWrite
    je  @1
    int $25
    jmp @2
   @1:
    int $26
   @2:
    jc @3
    xor ax,ax
   @3:
    popf
    pop ds
    pop bp
    xchg al,ah
    mov ExitCodeRWLS,ax
  end;
  if ExitCodeRWLS<>0 then begin
    GotoXY(1,slErrors); TextAttr:=7;
    Write('IO 訡.  ',Num,',  ',ExitCodeRWLS,'.'); ClrEol;
    if ioMode<>ioRead then Halt(1);
  end;
end;

{ =========== 楤 Display ᪨ 뤥ঠ ୮, 
ᮢ襭  祭  窨 ७   ⠭ ========== }

procedure Display;
const m:tParams=Pv_name; t:tParams=Pv_name;
var i:tParams; j:byte; s:string;
begin
  repeat

    { -- ᮢ -- }
    GotoXY(1,2); i:=t;
    repeat with Params[i] do begin
      if m=i then TextAttr:=$20 else TextAttr:=$02;
      write(params[i].name:40);
      case action of
	acFSEdit  : case FS of
	  fsFAT12: write('        FAT 12');
	  fsFAT16: write('        FAT 16');
	end;
	acDrvEdit : with desc[bVal^] do begin
	  write(' ':11);
	  if ln=0 then write(' ') else if Flag and 4 <> 0 then write('+') else write('-');
	  write(chr(bVal^+65),':',dr,'/',ln);
	end;
	acByteEdit: write(bVal^:14);
	acWordEdit: write(wVal^:14);
	acLongView,
	acLongEdit: write(lVal^:14);
	acStrEdit : begin
	  for j:=10 downto StrLen do write(' ');
	  write('"');
	  for j:=0 to StrLen do if sVal^[j]>=#32 then write(sVal^[j]) else write('?');
	  write('"');
	end;
      end;
      writeln; {$R-} inc(i); {$R+}
    end until WhereY=18;

    { --   -- }
    Key:=ReadKey; if Key=#0 then Key:=ReadKey;
    case Key of
      'H': if m=Low(tParams) then m:=High(tParams) else dec(m);
      'P': if m=High(tParams) then m:=Low(tParams) else inc(m);
      'F',
      #27: exit;
      #13: with Params[m] do begin
	gotoxy(42,2+ord(m)-ord(t)); ClrEol;
	case Action of
	  acStrEdit:  begin
	    readln(s);
	    for j:=0 to StrLen do
	      if j+1<=Length(s) then sVal^[j]:=s[j+1] else sVal^[j]:=' ';
	  end;
	  acByteEdit: readln(bVal^);
	  acWordEdit: readln(wVal^);
	  acLongEdit: readln(lVal^);
	  acFSEdit: if FS=fsFAT12 then FS:=fsFAT16 else FS:=fsFAT12;
	  acDrvEdit: begin
	    readln(s);
	    bVal^:=ord(UpCase(s[1]))-ord('A');
	    Key:='r'; exit;
	  end;
	end;
	TextAttr:=$04;
	GotoXY(1,slErrors+3); ClrEol;
	GotoXY(1,slErrors+2); ClrEol;
	GotoXY(1,slErrors+1); ClrEol;
	GotoXY(1,slErrors+0); ClrEol;
	if @Rout<>Nil then Rout(m);
      end;
    end;
    if t>m then t:=m;
    if Byte(t)<Byte(m)-15 then Byte(t):=Byte(m)-15;

  until False;
end;

{ ======== ⢥ 楤,  ன  ᮢ襭 㢥७ ========= }

procedure Format;
var
  s		: string;
  i		: Byte;
  nSec		: Longint;
  n		: Word;
  FreeSec	: tSector;
  pFillFAT	: Longint absolute FreeSec;

begin
  write('Format ? '); readln(s);
  if s<>'Y' then exit; ioMode:=ioWrite;
  writeln('BootRec...');
  BootSec[510]:=$55; BootSec[511]:=$AA; RWTS(BootSec,0);
  With BootRec do begin
    nSec:=res_sec;
    for i:=1 to fat_num do begin
      writeln('FAT # ',i,':');
      pFillFAT:=FSParams[FS].FillFAT; for n:=4 to bt2sc-1 do FreeSec[n]:=0;
      RWTS(FreeSec,nSec); inc(nSec);
      for n:=0 to bt2sc-1 do FreeSec[n]:=0;
      for n:=2 to sc2fat do begin
	write('  Sector # ',n,'...'#13);
	RWTS(FreeSec,nSec); inc(nSec);
      end;
      ClrEol;
    end;
    writeln('ROOT:');
    for n:=1 to root_size do begin
      write('  Sector # ',n,'...'#13);
      RWTS(FreeSec,nSec); inc(nSec);
    end;
    ClrEol;
  end;
  Writeln('Done.');
end;




{ ========   ⠫쭮 -   ࠧ ========= }


procedure Testout;
var t:tSector absolute BootRec; i:tParams;
begin
ioMode:=ioRead;                   repeat

rwts(t,0);


    BootRec.bt2sc:=bt2sc;
    with BootRec do begin
      media:=248; sign:=41;
      if desc[LDrive].ln<>0 then begin
	sec_num_o:=0; sec_num_n:=desc[LDrive].ln;
      end;
      if sec_num_o=0 then sec_num:=sec_num_n else sec_num:=sec_num_o;
      if root_ent<1 then root_ent:=1;
      if fat_num<1 then fat_num:=1;
      root_size:=(root_ent+15) div 16;
      fats_size:=sc2fat*fat_num;
      if sc2cl=0 then sc2cl:=1;
      if res_sec<1 then res_sec:=1;
      clast_num:=(sec_num-root_size-fats_size-res_sec) div sc2cl;
      if clast_num + 1 > $ff5 then FS:=fsFAT16 else FS:=fsFAT12;
      data_size:=clast_num*sc2cl;
      all_size:=data_size+root_size+fats_size+res_sec;
    end;
    subCalc0;



	display;                                  until key<>'r';


    with BootRec do begin
      if sec_num_o=0 then sec_num:=sec_num_n else sec_num:=sec_num_o;
      root_size:=(root_ent+15) div 16;
      fats_size:=sc2fat*fat_num;
      if sc2cl=0 then sc2cl:=1;
      clast_num:=(sec_num-root_size-fats_size-res_sec) div sc2cl;
      data_size:=clast_num*sc2cl;
      all_size:=data_size+root_size+fats_size+res_sec;
    end;



	if Key='F' then Format;


end;






begin
TextAttr:=$07; Writeln;
Writeln(' ।।  ᥣ ணᨢ 祫⢠:');
Writeln('  ண ।⠢ ᮡ ଠ, ।祭  ࠡ');
Writeln('    ࠩ஬ Sevilija,  ᮢ襭');
Writeln('    㬠, ⮬   筮 ,    㦥,');
Writeln('    ।⠢,      ࠡ.');
Writeln('     ⮫  ஢    ᯮ');
Writeln('  ᢮    謠.    , 祬  ᥡ ');
Writeln(' ।⠢.');

Writeln('  : ESC - 室; F,Y - Format; ENTER - ᬥ ப.');
ReadKey;

SearchLDrive; Linking; ClrScr;
TextAttr:=1; Write('  /+/   FORMATer for Professionals   (c)   Ravodin & ...   Version 1.0    2001');

testOut;


end.